#!/usr/bin/env python
# Generator of random IDEA messages with the same format as generated by
# LaBrea connector.

from __future__ import print_function
import sys
from argparse import ArgumentParser
import re
import os.path
import random
from uuid import uuid4
from datetime import datetime, timedelta
from time import strftime, gmtime
import json

DEFAULT_NAME = 'org.example.test.labrea'
DEFAULT_WINDOW = 900 # max detection window
DEFAULT_TIMEOUT = 300 # detection timeout
DEFAULT_TARGET_NET = '192.168.200.0/24'
DEFAULT_SOURCE_NET = '10.0.0.0/16'
DEFAULT_RATE = 360.0

RE_CIDR = '^\d+\.\d+\.\d+\.\d+/\d+$'
RE_IP = '^\d+\.\d+\.\d+\.\d+$'
# TODO IPv6 support

def ipstr2int(ipstr):
    parts = list(map(int, ipstr.split('.')))
    assert len(parts) == 4, "IP address must have 4 octets"
    assert all(0 <= part <= 255 for part in parts), "some octet is outside the 0-255 range"
    return (parts[0] << 24) | (parts[1] << 16) | (parts[2] << 8) | parts[3]

def int2ipstr(ipint):
    return '.'.join(map(str, (ipint >> 24, (ipint >> 16) & 0xff, (ipint >> 8) & 0xff, ipint & 0xff)))


class random_ip_generator:
    # Generates random IP addresses from given CIDR network
    # (it's implemented manually to avoid dependency on any nonstandard packages)
    def __init__(self, cidr):
        try:
            net, prefix_len = cidr.split('/')
            ipint = ipstr2int(net)
            prefix_len = int(prefix_len)
            assert 0 <= prefix_len <= 32, "prefix length must be integer between 0 and 32"
            mask = ~((1 << (32-prefix_len)) - 1) & 0xffffffff
            assert ipint & ~mask == 0, "host part contains non-zero bits"
        except Exception as e:
            raise ValueError("Invalid CIDR: " + str(e))
        self.ipint = ipint
        self.prefix_len = prefix_len
        # If singe IP address, redefine next() method
        if prefix_len == 32:
            self.next = lambda: net

    def next(self):
        return int2ipstr(self.ipint + random.getrandbits(32 - self.prefix_len))



parser = ArgumentParser(description="Generator of random IDEA messages with the same format as generated by LaBrea connector.")
parser.add_argument(metavar='TARGET_DIR', nargs='?', type=str, dest='dir',
                    help="Target directory to store the messages to (excluding 'incoming/' at the end). Print a message to stdout if not set.")
parser.add_argument('-c', metavar='CNT', dest='cnt', type=int, default=1,
                    help="Number of messages to generate (default: 1). Target directory must be set to allow more than one message.")
parser.add_argument('-n', '--name', metavar='NAME', type=str, default=DEFAULT_NAME,
                    help="Value of Node[0].Name field (default: '"+DEFAULT_NAME+"').")
parser.add_argument('-s', '--source', metavar='CIDR', type=str, default=DEFAULT_SOURCE_NET,
                    help="Network from which source addresses are generated (default: '"+DEFAULT_SOURCE_NET+"').")
parser.add_argument('-t', '--target', metavar='CIDR', type=str, default=DEFAULT_TARGET_NET,
                    help="IP range observed by the honeypot (default: '"+DEFAULT_TARGET_NET+"').")
parser.add_argument('--test', action='store_true',
                    help='Add "Test" to Category.')
parser.add_argument('-T', '--time', metavar='YYYY-MM-DDTHH:MM:SS', type=str,
                    help="EventTime of the first event (default: current time).")
parser.add_argument('-r', '--rate', metavar='N', type=float, default=DEFAULT_RATE,
                    help="Average number of alerts per hour (default: '"+str(DEFAULT_RATE)+"').")


args = parser.parse_args()

# Check validity of arguments

if not args.dir and args.cnt > 1:
    print("ERROR: Target directory must be set to generate more than one message.", file=sys.stderr)
    sys.exit(1)

if args.dir and not os.path.isdir(args.dir):
    print("ERROR: Target path doesn't exist or isn't a directory.", file=sys.stderr)
    sys.exit(1)

if args.name.isdigit():
    print("ERROR: Name should't be a number (if you try to set the number of messages, use -c)", file=sys.stderr)
    sys.exit(1)

try:
    src_gen = random_ip_generator(args.source)
except ValueError as e:
    print("ERROR in --source spcification: " + str(e), file=sys.stderr)
    sys.exit(1)

try:
    tgt_gen = random_ip_generator(args.target)
except ValueError as e:
    print("ERROR in --target spcification: " + str(e), file=sys.stderr)
    sys.exit(1)

if args.time:
    try:
        starttime = datetime.strptime(args.time, "%Y-%m-%dT%H:%M:%S")
    except ValueError as e:
        print("ERROR: Invalid EventTime: ", str(e), file=sys.stderr)
        sys.exit(1)
else:
    starttime = datetime.now()

# Create temp/ and incoming/ subdirectories if not exist
if args.dir:
    temp_path = os.path.join(args.dir, "temp")
    if not os.path.exists(temp_path):
        os.mkdir(temp_path)
    inc_path = os.path.join(args.dir, "incoming")
    if not os.path.exists(inc_path):
        os.mkdir(inc_path)

TEMPLATES = {
    "connect": {
        "category": ["Recon.Scanning"],
        "description": "TCP connections/scan",
        "template": "labrea-001",
        "note": "Connections from remote host to never assigned IP",
        "proto": ["tcp"]
    },
    "ping": {
        "category": ["Recon.Scanning"],
        "description": "Ping scan",
        "template": "labrea-002",
        "note": "Ping requests from remote host to never assigned IP",
        "proto": ["icmp"]
    },
    "synack": {
        "category": ["Availability.DoS"],
        "description": "Unsolicited TCP SYN/ACK connections/scan",
        "template": "labrea-003",
        "note": "Unsolicited SYN/ACK packet received from remote host to never assigned IP",
        "source_type": ["Backscatter"],
        "source_to_target": True,
        "proto": ["tcp"]
    }
}

# Commonly scanned ports
COMMON_TGT_PORTS = [
    21,
    22,
    23, 23, 23, 23,
    80,
    139,
    443,
    445, 445,
    1433, 1433,
    2323,
    3389,
    5060,
    5900,
    8080,
]
def get_random_port():
    return random.choice(COMMON_TGT_PORTS) if random.random() < 0.9 else random.randint(1,65535)

# Generate IDEA messages
for i in range(args.cnt):
    # Generate changing parts of message
    if random.random() < 0.25:
        # Many connections, longer duration
        conn_count = int(random.expovariate(0.02) + 1.0)
        duration = int(random.triangular(1,DEFAULT_WINDOW,DEFAULT_WINDOW))
    else:
        # Few connections, short duration
        conn_count = int(random.expovariate(0.5) + 1.0)
        duration = int(random.triangular(1,DEFAULT_WINDOW,1))
    
    if conn_count == 1:
        duration = 0
    
    event_time = starttime
    cease_time = event_time + timedelta(seconds=duration)
#     if duration > DEFAULT_WINDOW - DEFAULT_TIMEOUT:
#         # Message was sent because max window length was reached
#         detect_time = event_time + timedelta(seconds=DEFAULT_WINDOW)
#     else:
#         # Message was sent because detection timeout has expired
#         detect_time = cease_time + timedelta(seconds=DEFAULT_TIMEOUT)
    # I don't understand how detect_time is set in labrea connector's code, 
    # but all messages seems to have it set to EventTime + WINDOW + a second or two
    detect_time = event_time + timedelta(seconds=DEFAULT_WINDOW + int(random.expovariate(0.8) + 1.0))
    
    message_type = random.choice(['ping', 'connect', 'synack'])
    tmpl = TEMPLATES[message_type]
    
    # Target IPs and ports
    if message_type == "ping":
        targets = dict([(tgt_gen.next(), []) for _ in range(conn_count)])
    else:
        if message_type == "connect":
            # Number of target ports - usually just one (horizontal scan), sometimes more
            num_tgt_ports = 1 if random.random() < 0.8 else int(random.expovariate(0.5) + 1.0)
            tgt_ports = [get_random_port() for _ in range(num_tgt_ports)]
            # Random pairs of target IP and port (from given list of target ports)
            tgt_ip_port_list = [(tgt_gen.next(), random.choice(tgt_ports)) for _ in range(conn_count)]
        else: # message_type == "synack":
            tgt_ip_port_list = [(tgt_gen.next(), random.randint(1,65535)) for _ in range(conn_count)]
        # Tranform pairs to IP->list_of_ports mapping
        targets = {}
        for ip,port in tgt_ip_port_list:
            targets.setdefault(ip, set()).add(port)
    
    # Source IP and ports
    source = src_gen.next()
    if message_type == "connect":
        if random.random() < 0.5:
            # single port
            src_ports = [random.randint(1,65536)]
        else:
            # different port for each connection
            src_ports = [random.randint(1,65536) for _ in range(conn_count)]
    elif message_type == 'synack':
        # synack - backscatter from ddos
        src_ports = [random.randint(1,1024)]
    else:
        src_ports = []

    # Create message
    isource = {
        "IP6" if ":" in source else "IP4": [source],
        "Proto": tmpl["proto"]
    }
    if "source_type" in tmpl:
        isource["Type"] = tmpl["source_type"]
    if src_ports:
        isource["Port"] = [int(port) for port in src_ports]
    # Fold multiple IPs with the same portset
    folded_tgt = {}
    for tgt, ports in targets.items():
        folded_tgt.setdefault(frozenset(ports), []).append(tgt)
    itargets = []
    for ports, tgt in folded_tgt.items():
        itarget = {"Proto": tmpl["proto"]}
        tgts4 = [ip for ip in tgt if ":" not in ip]
        tgts6 = [ip for ip in tgt if ":" in ip]
        if tgts4:
            itarget["IP4"] = tgts4
        if tgts6:
            itarget["IP6"] = tgts6
        if ports:
            itarget["Port"] = [int(port) for port in ports]
        itargets.append(itarget)
    inode = {
        "SW": ["LaBrea"],
        "Type": ["Connection", "Tarpit"],
        "Name": args.name
    }
    idea = {
        "Format": "IDEA0",
        "ID": str(uuid4()),
        "Category": tmpl["category"] + (["Test"] if args.test else []),
        "Description": tmpl["description"],
        "DetectTime": detect_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "EventTime": event_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "CeaseTime": cease_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "ConnCount": conn_count,
        "Note": tmpl["note"],
        "_CESNET": {
            "EventTemplate": tmpl["template"],
        },
        "Target": itargets,
        "Node": [inode]
    }
    if tmpl.get("source_to_target", False):
        idea["Target"].append(isource)
    else:
        idea["Source"] = [isource]
    
    
    # Store the message
    if args.dir:
        # Write message to temp/ directory
        filename = idea['ID'] + ".idea"
        with open(os.path.join(temp_path, filename), "w") as f:
            json.dump(idea, f)
        # Atomically move it to incoming/ directory
        os.rename(os.path.join(temp_path, filename), os.path.join(inc_path, filename))
    else:
        # Print to stdout if directory is not given
        print(json.dumps(idea, indent=4))
    
    # Move time for the next message
    # (model it as Poisson process, i.e. exponentially distributed random delays with lambda = rate)
    starttime += timedelta(seconds=int(random.expovariate(args.rate)*3600))
